*	ORG	$D700
IC2ISR:
	LDAA	TCTRL2,X
	ANDA	#IC2TST
	CMPA	#IC2RISE
	BEQ	IC2RISEFNC
	CMPA	#IC2FALL
	BEQ	IC2FALLFNC
	LDAA	#IC2BIT
	STAA	TFLAG1,X
	RTI

IC2RISEFNC:
	LDD	TIC2,X
	STD	PWM2RISE
	BCLR	TCTRL2,X,IC2TST
	LDAA	TCTRL2,X
	ORAA	#IC2FALL
	STAA	TCTRL2,X
	LDAA	#IC2BIT
	STAA	TFLAG1,X
	RTI

IC2FALLFNC:
	LDD	TIC2,X				;SAVE TIC1 REGISTER CONTENTS INTO D REGISTER
	STD	PWM2FALL			;SAVE D REGISTER INTO RAM SPACE
	BCLR	TCTRL2,X,IC2TST			;BIT CLEAR THE BITS RELATED TO IC1 CONTROL
	LDAA	TCTRL2,X			;LOAD TO A THE TIMER CONTROL REGISTER 2
	ORAA	#IC2RISE			;CHANGE ONLY THE BITS RELATED TO IC1 AND RISE
	STAA	TCTRL2,X			;STORE NEW SETTINGS TO CONTROL REGISTER2

	LDAA	PWM2FALL			;LOAD ACC A WITH THE FALLING MSB VALUE
	LDAB	PWM2RISE			;LOAD ACC B WITH THE RISING MSB VALUE
	CBA					;COMPARE B AND A (A - B) TO CHECK IF RISING IS LOWER THAN FALLING
	BLE	REVIC2IN			;IF FALLING IS LOWER THAN RISING JUMP TO SUB
	LDD	PWM2FALL			;LOAD ACC D WITH THE FALLING 16 BIT VALUE
	SUBD	PWM2RISE			;D = D - RISE 16 BIT VALUE
	STD	PWM2RES				;STORE PWM1 RESULT ON RAM

	JSR	OC3OFFCALC

	LDAA	#IC2BIT
	STAA	TFLAG1,X
	RTI

REVIC2IN:
	LDD	#$FFFF
	SUBD	PWM2RISE
	ADDD	PWM2FALL
	STD	PWM2RES

	JSR	OC3OFFCALC

	LDAA	#IC2BIT
	STAA	TFLAG1,X
	RTI

OC3OFFCALC:
	LDD	PWM2RES
	SUBD	#SAFEOS
	STD	OC3OFF
	RTS

*HERE ENDS THE SERVICE ROUTINES FOR INPUT CAPTURE 2