*	WRITEBCD IS A SUBRUTINE WHICH WILL PRINT ON A LCD A 5 DIGIT	* 
*	DECIMAL NUMBER. FIVE DIGITS ARE STORED ON RAM (BCDX), 		*
*	WHERE BCD4 IS THE MOST SIGNIFICANT, AS A 16 BIT NUMBER. ONLY	*
*	THE LESS SIGNIFICANT BYTE HOLDS THE DIGIT IN ASCII FORMAT. DATA	*
*	IS SENT TO THE LCDWRITE SUBROUTINE TO DISPLAY ONE DIGIT.	* 


WRITEBCD:
	PSHA
	PSHB
	LDAB	BCD4+1
	JSR	WRTBCD2
	LDAB	BCD3+1
	JSR	WRTBCD2
	LDAB	BCD2+1
	JSR	WRTBCD2
	LDAB	BCD1+1
	JSR	WRTBCD2
	LDAB	BCD0+1
	JSR	WRTBCD2
	PULB
	PULA
	RTS

WRTBCD2:
	ANDB	#$0F
	LDY	#CHRPTR
	ABY	
	LDAA	$00,Y	
	JSR	LCDWRITE
	RTS

*	HEXTOBCD TAKES A VALUE FROM ACCUMULATOR D AND DIVIDES IT	*
*	BY A BASE 10 POWER STORED ON REGISTER X SUCCESIVELY UNTIL	*
*	LESS SIGNIFICANT DECIMAL DIGIT IS OBTAINED. USING IDIV		*
*	TAKES THE VALUE ON REGISTER D AND DIVIDES IT FROM THE VALUE	*
*	ON REGISTER X. RESULT IS STORED ON ACCUMULATOR D AND RESIDUAL	*
*	IN REGISTER X. RESIDUALS ARE THE DECIMAL DIGIT WHICH ARE	*
*	STORED IN RAM VARIABLES BEGINNING WITH THE MOST SIGNIFICATIVE	*

HEXTOBCD:
	PSHX
	LDX #10000
	IDIV
	STX BCD4
	LDX #1000
	IDIV
	STX BCD3
	LDX #100
	IDIV
	STX BCD2
	LDX #10
	IDIV
	STX BCD1
	STD BCD0
	PULX	
	RTS